Subject: Re: [Netconf] Netconf Digest, Vol 89, Issue 33

From: "Carey, Timothy (Timothy)" <[email-masked]>
Date: Sun, 26 Jul 2015 19:33:01 +0000

I would indeed like to have the XML mandatory text relaxed leaving it undefined as Juergen suggested.

BR,
Tim

-----Original Message-----
From: Netconf [mailto:[email-masked]] On Behalf Of [email-masked]
Sent: Sunday, July 26, 2015 7:06 PM
To: [email-masked]
Subject: Netconf Digest, Vol 89, Issue 33

Send Netconf mailing list submissions to
	[email-masked]

To subscribe or unsubscribe via the World Wide Web, visit
	https://www.ietf.org/mailman/listinfo/netconf
or, via email, send a message with subject or body 'help' to
	[email-masked]

You can reach the person managing the list at
	[email-masked]

When replying, please edit your Subject line so it is more specific than "Re: Contents of Netconf digest..."

Today's Topics:

   1. RESTCONF #24:mandatory encoding revisited (Andy Bierman)
   2. Re: RESTCONF #24:mandatory encoding revisited
      (Juergen Schoenwaelder)
   3. Re: RESTCONF #24:mandatory encoding revisited (Andy Bierman)
   4. Re: RESTCONF #24:mandatory encoding revisited
      (Ersue, Mehmet (Nokia - DE/Munich))

----------------------------------------------------------------------

Message: 1
Date: Sat, 25 Jul 2015 14:32:48 -0700
From: Andy Bierman <[email-masked]>
To: Netconf <[email-masked]>
Subject: [Netconf] RESTCONF #24:mandatory encoding revisited
Message-ID:
	<CABCOCHTAhdKP28EyiZzMrbDzTw9hrWxaT_7jT_=[email-masked]>
Content-Type: text/plain; charset="utf-8"

Hi,

It would be good if we could close this issue soon.
I am not in favor of changing the previous consensus call.

At first I thought JSON would be good for RESTCONF, until I implemented it.  It is not appropriate for streaming servers.
The complexity and memory required and just as bad or worse than XML, especially once namespaces and attributes are added.

JSON is fine if the entire document is in memory, but that's not how NETCONF/RESTCONF servers work.

Andy
-------------- next part --------------
An HTML attachment was scrubbed...
URL: <https://mailarchive.ietf.org/arch/browse/netconf/attachments/20150725/1655b097/attachment.html>

------------------------------

Message: 2
Date: Sun, 26 Jul 2015 09:26:14 +0200
From: Juergen Schoenwaelder <[email-masked]>
To: Andy Bierman <[email-masked]>
Cc: Netconf <[email-masked]>
Subject: Re: [Netconf] RESTCONF #24:mandatory encoding revisited
Message-ID: <[email-masked]>
Content-Type: text/plain; charset=us-ascii

On Sat, Jul 25, 2015 at 02:32:48PM -0700, Andy Bierman wrote:
> Hi,
> 
> It would be good if we could close this issue soon.
> I am not in favor of changing the previous consensus call.
> 
> At first I thought JSON would be good for RESTCONF, until I 
> implemented it.  It is not appropriate for streaming servers.
> The complexity and memory required and just as bad or worse than XML, 
> especially once namespaces and attributes are added.
> 
> JSON is fine if the entire document is in memory, but that's not how 
> NETCONF/RESTCONF servers work.

I would probably change my position from 'make XML mandatory' to leave it undefined. I do see scenarios where servers will only do JSON because this is what the clients they interact with expect.

/js

-- 
Juergen Schoenwaelder           Jacobs University Bremen gGmbH
Phone: +49 421 200 3587         Campus Ring 1 | 28759 Bremen | Germany
Fax:   +49 421 200 3103         <http://www.jacobs-university.de/>

------------------------------

Message: 3
Date: Sun, 26 Jul 2015 09:43:36 -0700
From: Andy Bierman <[email-masked]>
To: Juergen Schoenwaelder <[email-masked]>, Andy
	Bierman <[email-masked]>, Netconf <[email-masked]>
Subject: Re: [Netconf] RESTCONF #24:mandatory encoding revisited
Message-ID:
	<[email-masked]>
Content-Type: text/plain; charset="utf-8"

On Sun, Jul 26, 2015 at 12:26 AM, Juergen Schoenwaelder < [email-masked]> wrote:

> On Sat, Jul 25, 2015 at 02:32:48PM -0700, Andy Bierman wrote:
> > Hi,
> >
> > It would be good if we could close this issue soon.
> > I am not in favor of changing the previous consensus call.
> >
> > At first I thought JSON would be good for RESTCONF, until I 
> > implemented it.  It is not appropriate for streaming servers.
> > The complexity and memory required and just as bad or worse than 
> > XML, especially once namespaces and attributes are added.
> >
> > JSON is fine if the entire document is in memory, but that's not how 
> > NETCONF/RESTCONF servers work.
>
> I would probably change my position from 'make XML mandatory' to leave 
> it undefined. I do see scenarios where servers will only do JSON 
> because this is what the clients they interact with expect.
>
>

Could the XRD returned for the initial GET on  /.well-known be used to return the encoding formats supported by the server?
That way it will not cost an extra round-trip to find out if the server supports XML, JSON, or both.

If so, I would also change my position. Let the market decide if it is acceptable to be a JSON-only server.

/js

Andy

>
> --
> Juergen Schoenwaelder           Jacobs University Bremen gGmbH
> Phone: +49 421 200 3587         Campus Ring 1 | 28759 Bremen | Germany
> Fax:   +49 421 200 3103         <http://www.jacobs-university.de/>
>
-------------- next part --------------
An HTML attachment was scrubbed...
URL: <https://mailarchive.ietf.org/arch/browse/netconf/attachments/20150726/a01a91a4/attachment.html>

------------------------------

Message: 4
Date: Sun, 26 Jul 2015 17:06:14 +0000
From: "Ersue, Mehmet (Nokia - DE/Munich)" <[email-masked]>
To: ext Andy Bierman <[email-masked]>, Juergen Schoenwaelder
	<[email-masked]>, Netconf <[email-masked]>
Subject: Re: [Netconf] RESTCONF #24:mandatory encoding revisited
Message-ID:
	<[email-masked]>
Content-Type: text/plain; charset="utf-8"

I heard several times the argument that JSON would be the better choice for IoT.
Is RESTCONF indeed the right protocol for IoT?

Those who favor the use of RESTCONF + JSON for IoT should elaborate their use case.

Cheers,
Mehmet

From: Netconf [mailto:[email-masked]] On Behalf Of ext Andy Bierman
Sent: Sunday, July 26, 2015 6:44 PM
To: Juergen Schoenwaelder; Andy Bierman; Netconf
Subject: Re: [Netconf] RESTCONF #24:mandatory encoding revisited

On Sun, Jul 26, 2015 at 12:26 AM, Juergen Schoenwaelder <[email-masked]<mailto:[email-masked]>> wrote:
On Sat, Jul 25, 2015 at 02:32:48PM -0700, Andy Bierman wrote:
> Hi,
>
> It would be good if we could close this issue soon.
> I am not in favor of changing the previous consensus call.
>
> At first I thought JSON would be good for RESTCONF, until I 
> implemented it.  It is not appropriate for streaming servers.
> The complexity and memory required and just as bad or worse than XML, 
> especially once namespaces and attributes are added.
>
> JSON is fine if the entire document is in memory, but that's not how 
> NETCONF/RESTCONF servers work.

I would probably change my position from 'make XML mandatory' to leave it undefined. I do see scenarios where servers will only do JSON because this is what the clients they interact with expect.

Could the XRD returned for the initial GET on  /.well-known be used to return the encoding formats supported by the server?
That way it will not cost an extra round-trip to find out if the server supports XML, JSON, or both.

If so, I would also change my position. Let the market decide if it is acceptable to be a JSON-only server.

/js

Andy

--
Juergen Schoenwaelder           Jacobs University Bremen gGmbH
Phone: +49 421 200 3587         Campus Ring 1 | 28759 Bremen | Germany
Fax:   +49 421 200 3103         <http://www.jacobs-university.de/>

-------------- next part --------------
An HTML attachment was scrubbed...
URL: <https://mailarchive.ietf.org/arch/browse/netconf/attachments/20150726/2ad4ecf9/attachment.html>

------------------------------

Subject: Digest Footer

_______________________________________________
Netconf mailing list
[email-masked]
https://www.ietf.org/mailman/listinfo/netconf

------------------------------

End of Netconf Digest, Vol 89, Issue 33
***************************************